unit Unit1;    {$J+}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, JPEG,
  Menus, ExtCtrls, ExtDlgs, ComCtrls, clipbrd;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    OpenJpeg: TOpenPictureDialog;
    SaveJpeg: TSavePictureDialog;
    Image1: TImage;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    mnuExit: TMenuItem;
    SB: TStatusBar;
    setupActions: TMenuItem;
    Savetoclipboard1: TMenuItem;
    mnuJigsaw: TMenuItem;
    mnuHelp: TMenuItem;
    Exchangeblocks1: TMenuItem;
    CopyBlock1: TMenuItem;
    EraseBlock1: TMenuItem;
    Writetransparenttext1: TMenuItem;
    About1: TMenuItem;
    Help1: TMenuItem;
    Exchangefixedblocks1: TMenuItem;
    ResetImage1: TMenuItem;
    ShowBlockOrdesrs1: TMenuItem;
    Copyfixedblockduplicate1: TMenuItem;
    Randomizeblocks1: TMenuItem;
    Writeblockno1: TMenuItem;
    mnuShrinkimage: TMenuItem;
    SaveCroptofile1: TMenuItem;
    mnusavcrop2clip: TMenuItem;
    Shift1: TMenuItem;
    RowtoRight1: TMenuItem;
    mnuRowtoLeft: TMenuItem;
    ColumnUp1: TMenuItem;
    ColumnDn1: TMenuItem;
    N2: TMenuItem;
    N1: TMenuItem;
    Pasteimage1: TMenuItem;
    mnuerasefixblk: TMenuItem;
    N3: TMenuItem;
    mnurotarbiblk: TMenuItem;
    mnurotfixed180: TMenuItem;
    procedure mnuExitClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Exchangeblocks1Click(Sender: TObject);
    procedure CopyBlock1Click(Sender: TObject);
    procedure mnuErasearbitBlockclik(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Writetransparenttext1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure About1Click(Sender: TObject);
    procedure Savetoclipboard1Click(Sender: TObject);
    procedure Exchangefixedblocks1Click(Sender: TObject);
    procedure ResetImage1Click(Sender: TObject);
    procedure setupActionsClick(Sender: TObject);
    procedure ShowBlockOrdesrs1Click(Sender: TObject);
    procedure Randomizeblocks1Click(Sender: TObject);
    procedure Writeblockno1Click(Sender: TObject);
    procedure mnuShrinkimageClick(Sender: TObject);
    procedure SaveCroptofile1Click(Sender: TObject);
    procedure mnusavcrop2clipClick(Sender: TObject);
    procedure Copyfixedblockduplicate1Click(Sender: TObject);
    procedure RowtoRight1Click(Sender: TObject);
    procedure Pasteimage1Click(Sender: TObject);
    procedure mnuRowtoLeftClick(Sender: TObject);
    procedure ColumnUp1Click(Sender: TObject);
    procedure ColumnDn1Click(Sender: TObject);
    procedure mnuerasefixblkClick(Sender: TObject);
    procedure mnurotarbiblkClick(Sender: TObject);
    procedure mnurotfixed180Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ExchgJigsawBlocks(r1,c1,r2,c2 : integer);
    procedure RotateRowCol(row,col,action : integer);
    { Public declarations }
  end;

var
  Form1: TForm1;
  JigBitmap, srcbitmap,destbitmap, mainbitmap : tbitmap;
  jigcodes : array[1..20,1..20] of word;
  const ready : boolean =false; Totcols : integer =4; TotRows : integer =4;
implementation

uses UnitMisc, Unit2;

{$R *.DFM}

var  x1,y1,x2,y2,jigcode,NowX,NowY : integer; JRect : TRect;
     jigaction :(none, writetext, jigsaw,jigsawblock, dupjigsawblock, dupblock,
     EraseArbitBlock,EraseFixedBlock, crop2JPG, crop2clip, RotateRowRt, RotateRowLt,
     RotateColUp,RotatecolDn,RotCell90,RotCell180,RotCell270,RotArbit180);


procedure Exchange(var a,b : integer);
var i : integer;
begin i:=a; a:=b; b:=i
end;

function AbsInteger(n : integer) : integer;
begin if n<0 then result:=-n else result:=n
end;

procedure ExchangeCellCodes(r1,c1,r2,c2 : integer);
var i : byte;
begin i:=jigcodes[r1,c1]; jigcodes[r1,c1]:=jigcodes[r2,c2];
    jigcodes[r2,c2]:=i
end;

procedure TForm1.ExchgJigsawBlocks(r1,c1,r2,c2 : integer);
var  rows,cols,w,h : integer;  RT1,RT2 : Trect; T : Tbitmap;
begin if (r1=r2)and(c1=c2) then
      exit;
      w:=jigbitmap.Width; h:=jigbitmap.Height;
      rows:=Totrows; cols:=totcols;
      w:=w div cols; h:=h div rows;
      t:=Tbitmap.Create; t.Width:=w; t.Height:=h; t.PixelFormat:=pf32bit;
      RT1.Left:=(c1-1)*w; RT1.Top:=(r1-1)*h; RT1.Right:=c1*w; RT1.Bottom:=r1*h;
      RT2.Left:=(c2-1)*w; RT2.Top:=(r2-1)*h; RT2.Right:=c2*w; RT2.Bottom:=r2*h;
      t.Canvas.CopyRect(rect(0,0,w,h),jigbitmap.canvas,RT1);
      jigbitmap.Canvas.CopyRect(RT1,jigbitmap.canvas,RT2);
      jigbitmap.Canvas.CopyRect(RT2,t.canvas,rect(0,0,w,h));
      image1.picture.Bitmap.Assign(jigbitmap);
      ExchangeCellCodes(r1,c1,r2,c2); t.Free
end;

procedure TForm1.RotateRowCol(row,col,action : integer);
var w,h,i : integer; RT1,RT2 : Trect;

begin image1.Picture.Bitmap.Assign(jigbitmap);
 w:=mainbitmap.Width div totcols; h:=mainbitmap.Height div totrows;
 case action of
  0: begin //rotate a row 1 cell to the right
         RT1.Left:=0; RT1.Right:=(totcols-1)*w;
         RT1.Top:=(row-1)*h; RT1.Bottom:=row*h;
         RT2:=RT1; RT2.Left:=w; RT2.Right:=totcols*w;
         jigbitmap.Canvas.CopyRect(RT2,image1.canvas,RT1);
         RT1.Right:=w; RT2.Left:=(totcols-1)*w; RT2.Right:=totcols*w;
         jigbitmap.Canvas.CopyRect(RT1,image1.canvas,RT2);
         //now we update blocks jigsaw codes
         w:=jigcodes[row,totcols];
         for i:=totcols downto 2 do jigcodes[row,i]:=jigcodes[row,i-1];
         jigcodes[row,1]:=w
     end;
  1: begin //rotate row 1 cell to the left
         RT1.Left:=w; RT1.Top:=(row-1)*h;
         RT1.Right:=totcols*w; RT1.Bottom:=row*h;
         RT2:=RT1;  RT2.Left:=0;
         RT2.Right:=(totcols-1)*w;
         jigbitmap.Canvas.CopyRect(RT2,image1.canvas,RT1);
         RT1.Left:=0; RT1.Right:=w; RT2.Left:=(totcols-1)*w; RT2.Right:=totcols*w;
         jigbitmap.Canvas.CopyRect(RT2,image1.canvas,RT1);
         //now we update blocks jigsaw codes
         w:=jigcodes[row,1];
         for i:=1 to totcols-1 do jigcodes[row,i]:=jigcodes[row,i+1];
         jigcodes[row,totcols]:=w
     end;
  2: begin //rotate col 1 cell UP
          RT1.Left:=(col-1)*w; RT1.Right:=col*w; RT1.Top:=0; RT1.Bottom:=(totrows-1)*h;
          RT2:=RT1; RT2.Top:=h; RT2.Bottom:=(totrows)*h;
          jigbitmap.Canvas.CopyRect(RT1,image1.canvas,RT2);
          RT2.Top:=0; RT2.Bottom:=h; //now we excanhe top and bot cells
          RT1.Top:=(totrows-1)*h; RT1.Bottom:=totrows*h;
          jigbitmap.Canvas.CopyRect(RT1,image1.canvas,RT2);
          //now we update blocks jigsaw codes
         w:=jigcodes[1,col];
         for i:=1 to totrows-1 do jigcodes[i,col]:=jigcodes[i+1,col];
         jigcodes[totrows,col]:=w
     end;
  3: begin //rotate col 1 cell down
          RT1.Left:=(col-1)*w; RT1.Right:=col*w; RT1.Top:=0; RT1.Bottom:=(totrows-1)*h;
          RT2:=RT1; RT2.Top:=h; RT2.Bottom:=(totrows)*h;
          jigbitmap.Canvas.CopyRect(RT2,image1.canvas,RT1);
          RT1.Top:=0; RT1.Bottom:=h; RT2.Top:=(totrows-1)*h; RT2.Bottom:=totrows*h;
          jigbitmap.Canvas.CopyRect(RT1,image1.canvas,RT2);
          w:=jigcodes[totrows,col];
          for i:=totrows downto 2 do jigcodes[i,col]:=jigcodes[i-1,col];
          jigcodes[1,col]:=w
     end;
  end;
  image1.Picture.Bitmap.Assign(jigbitmap);
end;

procedure TForm1.mnuExitClick(Sender: TObject);
begin close
end;

procedure TForm1.FormCreate(Sender: TObject);
label T1;
begin  JigBitmap:=Tbitmap.Create; JigBitmap.PixelFormat:=pf32bit;
 srcbitmap:=tbitmap.create;  srcbitmap.PixelFormat:=pf32bit;
 destbitmap:=tbitmap.create;  destbitmap.PixelFormat:=pf32bit;
 mainbitmap:=tbitmap.create;  mainbitmap.PixelFormat:=pf32bit;
 form1.DoubleBuffered:=true;
 if paramstr(1)<>'' then
 begin openjpeg.FileName:=paramstr(1);
       if fileexists(openjpeg.FileName)=false then goto T1;
       open1click(nil);
 end else with mainbitmap do
 begin T1:
       width:=image1.width; height:=image1.height; canvas.Brush.Style:=bssolid;
       canvas.Brush.Color:=$F0E0F0; canvas.FillRect(rect(0,0,width,height));
       canvas.Pen.Color:=0; canvas.Pen.Width:=2;
       canvas.Ellipse(10,10,width-10,height-10); canvas.Font.Name:='ARIAL';
       canvas.Font.Size:=18; canvas.TextOut(width div 3,height div 2,'Select an image first');
       jigbitmap.Assign(mainbitmap);
       image1.picture.Bitmap.Assign(mainbitmap); ready:=true
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   jigbitmap.Free; mainbitmap.Free;
   srcbitmap.Free; destbitmap.Free
end;

procedure TForm1.Open1Click(Sender: TObject);
var j : Tjpegimage; label next;
begin if sender=nil then goto next;;
 if openjpeg.Execute=false then exit;
  ready:=false;
 frmmisc.cbusegrid.Checked:=false;
 next:
 if fileexists(openjpeg.filename)=false then exit;
 j:=Tjpegimage.Create; j.PixelFormat:=jf24Bit;
 j.LoadFromFile(openjpeg.filename);
 JigBitmap.Assign(j); ready:=true;
 mainbitmap.Assign(j);
 image1.Picture.bitmap.Assign(JigBitmap);
 j.Free
end;

procedure TForm1.Save1Click(Sender: TObject);
var j : Tjpegimage;
begin if ready=false then exit; savejpeg.FilterIndex:=1;
  if savejpeg.Execute=false then exit;
  j:=tjpegimage.Create; j.PixelFormat:=jf24Bit;  j.CompressionQuality:=100;
  j.Assign(JigBitmap);
  j.SaveToFile(savejpeg.filename); j.Free;
  showmessage('File was saved to '+ savejpeg.filename)
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p : Tpoint; i,j,x4,y4,x5,y5,w,h,cellx,celly : integer;
    JP : Tjpegimage; R : Trect;  label T1;
begin  w:=jigbitmap.Width div totcols; h:=jigbitmap.Height div totrows;
   case jigaction of
   JigSaw,DupBlock:
   begin inc(jigcode);
         if jigcode=2 then
         begin
               p.x:=x1; p.y:=y1; p:=ClientToScreen(p);
               setcursorpos(p.x,p.y); i:=absinteger(x2-x1); j:=absinteger(y2-y1);
               srcbitmap.Width:=i; srcbitmap.Height:=j;
               destbitmap.Width:=i; destbitmap.Height:=j;
               x4:=x1; y4:=y1;  x5:=x2; y5:=y2;
               if x4>x5 then Exchange(x4,x5);
               if y4>y5 then Exchange(y4,y5);

               srcbitmap.Canvas.CopyRect(rect(0,0,i,j),JigBitmap.canvas,rect(x4,y4,x5,y5));
         end else
         if jigcode=3 then
         begin T1:
              JigBitmap.Assign(image1.picture.bitmap);
              jigcode:=0
         end
    end;

    RotArbit180:
    begin inc(jigcode);
          if jigcode=2 then
          begin i:=absinteger(x2-x1); j:=absinteger(y2-y1); jigcode:=0;
               srcbitmap.Width:=i; srcbitmap.Height:=j;
               x4:=x1; y4:=y1;  x5:=x2; y5:=y2;
               if x4>x5 then Exchange(x4,x5);
               if y4>y5 then Exchange(y4,y5);
               srcbitmap.Canvas.CopyRect(rect(0,0,i,j),JigBitmap.canvas,rect(x4,y4,x5,y5));
               TurnBitmap(180,srcbitmap);
               jigbitmap.Canvas.CopyRect(rect(x4,y4,x5,y5),srcbitmap.canvas,rect(0,0,i,j));
               image1.Picture.Bitmap.Assign(jigbitmap)
          end;
    end;

    EraseArbitBlock:
    begin inc(jigcode);
          if jigcode=2 then
          begin p.x:=x1; p.y:=y1; p:=ClientToScreen(p);
               setcursorpos(p.x,p.y);
               goto T1
          end else if jigcode=3 then goto T1
    end;

    EraseFixedBlock :
     begin
         MouseCellcoord(jigbitmap,TotCols,TotRows,x,y,cellx,celly,R);
         with jigbitmap.Canvas do
         begin brush.Style:=bssolid; brush.Color:=frmmisc.Shape1.Brush.Color;
               fillrect(R); image1.Picture.Bitmap.Assign(mainbitmap)
         end
     end;

    writetext:
    begin inc(jigcode);
          if jigcode=1 then
          begin jigcode:=0; jigbitmap.Assign(image1.picture.bitmap)
          end
    end;

   jigsawblock,dupjigsawblock:
          begin inc(jigcode);
               if jigcode=1 then //we need to see which cell mouse was clicked
               begin image1.Cursor:=crDrag;
                     MouseCellcoord(jigbitmap,TotCols,TotRows,x,y,x1,y1,R);
                     //w:=R.Right-R.Left+1; h:=R.Bottom-R.Top+1;
                     JRect:=R;
                     srcbitmap.Width:=w; srcbitmap.Height:=h;
                     destbitmap.Width:=w; destbitmap.Height:=h;
                     srcbitmap.Canvas.CopyRect(rect(0,0,w,h),jigbitmap.canvas,R)
               end else if jigcode=2 then
               begin jigcode:=0;
                     MouseCellcoord(jigbitmap,TotCols,TotRows,x,y,cellx,celly,R);
                     if (cellx=x1)and(celly=y1) then
                     begin showmessage('Source and destination cells can not be same');
                           jigcode:=1; exit
                     end;
                     //w:=R.Right-R.Left; h:=R.Bottom-R.Top;
                     jigbitmap.Canvas.CopyRect(R,srcbitmap.canvas,rect(0,0,w,h));
                     if jigaction=jigsawblock then
                     jigbitmap.Canvas.CopyRect(JRect,destbitmap.canvas,rect(0,0,w,h));
                     if jigaction=jigsawblock then
                     ExchangeCellCodes(y1,x1,celly,cellx) else
                     jigcodes[celly,cellx]:=jigcodes[y1,x1];
                     image1.picture.bitmap.Assign(jigbitmap);
                     image1.Cursor:=crHandPoint;
               end
           end;

      crop2JPG,crop2clip : begin inc(jigcode); if jigcode=2 then
                       begin jigcode:=0;
                           w:=absinteger(x-x1); h:=absinteger(y-y1);
                           srcbitmap.Width:=w; srcbitmap.Height:=h;
                           srcbitmap.Canvas.CopyRect(rect(0,0,w,h),jigbitmap.canvas,
                           rect(x1,y1,x,y));
                           if jigaction=crop2JPG then
                           begin  if SaveJpeg.Execute=false then exit;
                           jp:=Tjpegimage.Create; jp.PixelFormat:=jf24Bit; jp.CompressionQuality:=100;
                           jp.Assign(srcbitmap); jp.SaveToFile(saveJpeg.filename); jp.Free;
                           showmessage('Crop area was saved to file')
                           end else
                           begin clipboard.Assign(srcbitmap);
                                 showmessage('Croped area was copied to clipboard')
                           end
                       end end;
      RotateRowRt,RotateRowLt,RotateColUp,RotateColDn :
                   begin
                     MouseCellcoord(jigbitmap,Totcols,totrows,x,y,CellX,CellY,R);
                     case jigaction of
                      RotateRowRt : RotateRowCol(celly,cellx,0);
                      RotateRowLt : RotateRowCol(celly,cellx,1);
                      RotateColUp : RotateRowCol(celly,cellx,2);
                      RotateColDn : RotateRowCol(celly,cellx,3);
                     end
                    end;

          RotCell180 :
              begin
               MouseCellcoord(jigbitmap,Totcols,totrows,x,y,CellX,CellY,R);
               w:=jigbitmap.width div totcols; h:=jigbitmap.Height div totrows;
               srcbitmap.Width:=w; srcbitmap.Height:=h;
               srcbitmap.Canvas.CopyRect(rect(0,0,w,h),JigBitmap.canvas,R);
               TurnBitmap(180,srcbitmap);
               jigbitmap.Canvas.CopyRect(R,srcbitmap.canvas,rect(0,0,w,h));
               image1.Picture.Bitmap.Assign(jigbitmap)

              end;
             end //case
end; //MouseDown

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
var  x4,y4,x5,y5,h,w,i,hh,ww,cellx,celly : integer;
     R : Trect;  label T1,T2 ;

procedure Common1;
begin
       sb.Panels[1].Text:='Row='+inttostr(celly)+' Col='+inttostr(cellx)+
       '  Cell '+inttostr((celly-1)*totcols+cellx);
end;

begin
 h:=jigbitmap.Canvas.Pixels[x,y];
 sb.Panels[0].Text:='X='+inttostr(x)+'  Y='+inttostr(y)+'   '+inttohex(h,6);
 nowx:=x; nowy:=y;
 image1.Picture.bitmap.Assign(JigBitmap);

 w:=jigbitmap.Width div totcols; h:=jigbitmap.Height div totrows;
 MouseCellcoord(jigbitmap,Totcols,totrows,x,y,CellX,CellY,R);

 with frmmisc do if cbusegrid.Checked and cbinvisible.Checked then
 begin
       image1.Canvas.DrawFocusRect(R);common1
 end;


 case jigaction of
  RotateRowRt,RotateRowLt,RotateColUp,RotateColDn,RotCell180 :
       begin common1;

       end;

  crop2jpg,crop2clip :
  case jigcode of
    0 : goto T1;
    1 : goto T2;
   end;

  jigsawblock,dupjigsawblock:  //for fixed bloks sizes
       begin common1;


           if jigcode=0 then
           else
           begin

             if (R.Left<>Jrect.Left)or(R.Right<>JRect.Right)or
             (R.Top<>Jrect.Top)or(R.Bottom<>Jrect.Bottom) then
             begin
               w:=srcbitmap.Width; h:=srcbitmap.Height;
               destbitmap.Canvas.CopyRect(rect(0,0,w,h),JigBitmap.canvas,R);
               image1.Canvas.CopyRect(R,srcbitmap.canvas,rect(0,0,w,h));
               if jigaction=jigsawblock then
               image1.Canvas.CopyRect(JRect,destbitmap.canvas,rect(0,0,w,h))
             end
            end
       end;

 JigSaw,DupBlock,RotArbit180 : // for arbitrary block size
 begin
   case jigcode of
    0 : begin T1:
             image1.Canvas.DrawFocusRect(rect(x,y,x+100,y+100));
             x1:=x; y1:=y
       end;
    1 : begin T2:
              x4:=x1; y4:=y1;
              x5:=x; y5:=y; x2:=x; y2:=y;
              if x4>x5 then Exchange(x4,x5);
              if y4>y5 then Exchange(y4,y5);
              image1.Canvas.DrawFocusRect(rect(x4,y4,x5,y5));

              w:=x5-x4; h:=y5-y4;
              sb.Panels[1].Text:='W='+inttostr(absinteger(w))+
              '  H='+inttostr(absinteger(h))
        end;
    2 : begin h:=y2-y1; w:=x2-x1; h:=absinteger(h); w:=absinteger(w);
            image1.Picture.Bitmap.Assign(JigBitmap);
            x4:=x; y4:=y;
            destbitmap.Canvas.CopyRect(rect(0,0,w,h),JigBitmap.canvas,rect(x4,y4,x4+w,y4+h));
            image1.Canvas.CopyRect(rect(x4,y4,x4+w,y4+h),srcbitmap.canvas,rect(0,0,w,h));
            x4:=x1; y4:=y1; x5:=x2; y5:=y2;
            if x4>x5 then Exchange(x4,x5);
            if y4>y5 then Exchange(y4,y5);

            if jigaction=jigsaw then //exchange the 2 blocks
            image1.canvas.CopyRect(rect(x4,y4,x5,y5),destbitmap.canvas,rect(0,0,w,h))
         end
    end
    end;

    EraseArbitBlock:
    begin
        case jigcode of
        0 : goto T1;
        1 : with image1.canvas do
           begin //image1.Picture.bitmap.Assign(JigBitmap);
              x4:=x1; y4:=y1;
              x5:=x; y5:=y;
              if x4>x5 then Exchange(x4,x5);
              if y4>y5 then Exchange(y4,y5);
              image1.Canvas.DrawFocusRect(rect(x4,y4,x5,y5));
              x1:=x4; y1:=y4; x2:=x5; y2:=y5;
              sb.Panels[1].Text:='W='+inttostr(x2-x1)+'  H='+inttostr(y2-y1);
              brush.Style:=bssolid;
              brush.Color:=frmmisc.Shape1.Brush.Color;
              FillRect(rect(x4,y4,x5,y5))
          end;
        end;
     end;

    writetext:
    begin if form1.Focused then else form1.SetFocus;
          i:=strtointdef(frmmisc.edit2.text,100);
          if (i>100)or(i<2) then i:=100;
          TextOutTransparent(frmmisc.edit1.text,x,y,i);
          w:=destbitmap.Width; h:=destbitmap.Height;
          ww:=w div 2; hh:=h div 2;
          image1.Canvas.CopyRect(rect(x-ww,y-hh,x+ww,y+hh),destbitmap.canvas,rect(0,0,w,h))
    end;
    end
end; //MouseMove

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin if key=#27 then
  begin jigaction:=none; image1.Picture.Assign(JigBitmap);
        image1.Cursor:=crdefault; sb.Panels[2].Text:=''
  end
end;

procedure TForm1.Exchangeblocks1Click(Sender: TObject);
const i : integer=0;
begin if ready=false then exit;
   if frmmisc.cbusegrid.Checked then
   begin showmessage('When grid lines enabled you can only exchange fixed blocks');
         exit
   end;
   image1.Cursor:=crDefault;
   jigaction:=jigsaw; jigcode:=0; image1.Canvas.Brush.Style:=bssolid;
   if i=0 then
   begin showmessage('2 click to select the rectangle, dont hold mouse key down');
         inc(i)
   end;
   sb.Panels[2].Text:='Exch arbit blocks'
end;

procedure TForm1.SaveCroptofile1Click(Sender: TObject);
const i : integer=0;
begin if ready=false then exit;
   jigaction:=crop2JPG; jigcode:=0; image1.Canvas.Brush.Style:=bssolid;
   if i=0 then
   begin showmessage('2 click to select the crop rectangle to be saved as JPG file'+
       ', dont hold mouse key down');
         inc(i)
   end
end;

procedure TForm1.mnusavcrop2clipClick(Sender: TObject);
const i : integer=0;
begin if ready=false then exit;
   jigaction:=crop2clip; jigcode:=0; image1.Canvas.Brush.Style:=bssolid;
   if i=0 then
   begin showmessage('2 click to select the crop rectangle to be copied to clipboard'+
       ', dont hold mouse key down');
         inc(i)
   end
end;

procedure TForm1.Exchangefixedblocks1Click(Sender: TObject);
const i : integer=0; var j,k,n : integer;
begin if ready=false then exit;
   if frmmisc.cbusegrid.Checked=false then
   begin showmessage('Grid lines must be enabled');
         exit
   end;
   image1.Cursor:=crDefault;
   if sender=nil then
   begin jigaction:=dupjigsawblock; //current fixed block will be copied new location and dest is lost
         sb.Panels[2].Text:='Dup fixed blocks'
   end
   else
   begin jigaction:=jigsawblock; //current fixed block will be exchanged with dest
         sb.Panels[2].Text:='Exchg fixed blocks'
   end;

   jigcode:=0; image1.Canvas.Brush.Style:=bssolid;
   image1.Cursor:=crHandPoint;
   if i=0 then
   begin showmessage('1st click near the center of the source block,'+
         '2nd click near center of destination block');
         inc(i)
   end;
   n:=0; fillchar(jigcodes,sizeof(jigcodes),0);
   for j:=1 to Totrows do for k:=1 to Totcols do
   begin inc(n); jigcodes[j,k]:=n
   end
end;

procedure TForm1.mnurotfixed180Click(Sender: TObject);
const c : boolean=true;
begin
 if frmmisc.cbusegrid.Checked=false then
 begin showmessage('Grid lines not enabled');
       exit
 end;
 if c then
 begin c:=false;
       showmessage('A single click on any cell will turn it 180 deg');
 end;
 jigaction:=RotCell180
end;

procedure TForm1.mnuerasefixblkClick(Sender: TObject);
const i : boolean= true;
begin
 if frmmisc.cbusegrid.Checked=false then
 begin showmessage('Grid lines not enabled for fix block erasure');
       exit   
 end;
 sb.Panels[2].Text:='Erase fix block'; jigaction:=EraseFixedBlock;
 if i then
 begin i:=false;
      showmessage('click on any cell and it will be erased according'+
       'to color you have selected')
 end
end;


procedure TForm1.Copyfixedblockduplicate1Click(Sender: TObject);
begin jigaction:=dupjigsawblock;
   Exchangefixedblocks1Click(nil)
end;

procedure TForm1.CopyBlock1Click(Sender: TObject);
const i : integer=0;
begin if ready=false then exit;
   if frmmisc.cbusegrid.Checked then
   begin showmessage('When grid lines enabled you can only duplicate fixed blocks');
         exit
   end;
   image1.Canvas.Brush.Style:=bssolid;
   jigaction:=dupblock; jigcode:=0; image1.Cursor:=crDefault;
   if i=0 then
   begin showmessage('2 click to select the rectangle, dont hold mouse key down');
         inc(i)
   end;
   sb.Panels[2].Text:='Dup/copy arbit blocks'
end;

procedure TForm1.mnuErasearbitBlockclik(Sender: TObject);
const i : integer=0;
begin if ready=false then exit;
   if frmmisc.cbusegrid.Checked then
   begin showmessage('When grid lines enabled you can only erase fixed blocks');
         exit
   end;
   image1.Canvas.Brush.Style:=bssolid;
   jigaction:=EraseArbitBlock; jigcode:=0; image1.Cursor:=crDefault;
   if i=0 then
   begin showmessage('2 click to select the rectangle to be erased, dont hold mouse key down');
         inc(i)
   end;
   sb.Panels[2].Text:='Erase arbit blocks'
end;

procedure TForm1.mnurotarbiblkClick(Sender: TObject);
const i : boolean=true;
begin if i then
      begin i:=false;
            showmessage('After selecting a block by 2 clicks it will be rotated 180 deg')
      end;
      jigaction:=RotArbit180; jigcode:=0
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var p : Tpoint;
begin  getcursorpos(p);
     case key of
         vk_up : dec(p.y);
         vk_down: inc(p.y);
         vk_right: inc(p.x);
         vk_left: dec(p.x);
         else exit
      end;
      setcursorpos(p.x,p.y)
end;

procedure TForm1.Writetransparenttext1Click(Sender: TObject);
const i : integer=0;
begin if ready=false then exit;
   jigaction:=writetext; jigcode:=0; image1.Cursor:=crDefault;
   if i=0 then
   begin inc(i); showmessage('You can use mousewheel for transparency control')
   end;
   frmmisc.Show
end;

procedure TForm1.Help1Click(Sender: TObject);
begin frmmisc.Show
end;

procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  var i : integer;
begin i:=strtointdef(frmmisc.edit2.text,100);
    if wheeldelta>0 then inc(i) else if wheeldelta<0 then dec(i);
    if i>100 then i:=100 else if i<2 then i:=2;
    frmmisc.edit2.text:=inttostr(i); handled:=true;
    Image1MouseMove(nil,[],nowx,nowy)
end;

procedure TForm1.About1Click(Sender: TObject);
begin
showmessage('This is a freeware Jigsaw app written in Delphi 7 with full source code'+#13#10+
'by Omid Motahed motahed1@yahoo.com    www.Facebook.com/motahed')
end;

procedure TForm1.Savetoclipboard1Click(Sender: TObject);
begin clipboard.Assign(jigbitmap);
 showmessage('Image was copied to clipboard');
end;

procedure TForm1.ResetImage1Click(Sender: TObject);
begin if ready=false then exit;
 ready:=false; frmmisc.cbusegrid.Checked:=false;
 frmmisc.cbinvisible.Checked:=false;  image1.Cursor:=crDefault;
 image1.picture.bitmap.assign(mainbitmap);
 jigbitmap.Assign(mainbitmap); jigaction:=none;
 ready:=true 
end;

procedure TForm1.setupActionsClick(Sender: TObject);
begin frmmisc.Show; frmmisc.Left:=1; frmmisc.BringToFront
end;

procedure TForm1.ShowBlockOrdesrs1Click(Sender: TObject);
var s : string; i,j,m,n,a,k : integer; t : array[1..100] of word;
begin if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled yet');
        exit
  end;
  m:=TotRows; n:=Totcols; k:=0;
  fillchar(t,sizeof(t),0); //basic initialization
  s:='';

  for i:=1 to m do for j:=1 to n do
  begin  a:=jigcodes[i,j]; inc(k); t[k]:=a;
  end;

  i:=m*n;
  for k:=1 to i do
  begin
        for j:=1 to i do if t[j]=k then //find the position
        begin s:=s+inttostr(j)+' ';
              break
        end
  end;
  clipboard.AsText:=s; showmessage(s+#13+' Copied to clipboard')
end;

procedure TForm1.Randomizeblocks1Click(Sender: TObject);
var i,k,j,rows,cols,j1,j2,j3,j4,tot : integer;
begin if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled');
        exit
  end;
  randomize; k:=0;
  if totrows>2 then
  for i:=1 to totrows do
  begin inc(k);
        for j:=1 to random(3) do
        begin
        if odd(k) then
        RotateRowCol(i,1,0) else RotateRowCol(i,1,1)
        end
  end;

  if totcols>2 then
  for i:=1 to totcols do
  begin inc(k);
       for j:=1 to random(4) do
       begin
       if odd(k) then
       RotateRowCol(1,i,2) else RotateRowCol(1,i,3)
       end
  end;
  (*   alternate method of randomization of blocks
  rows:=TotRows; cols:=Totcols;
  k:=2*rows*cols; tot:=0; image1.Cursor:=crDefault;
  for i:=1 to k do
  begin j1:=random(rows); inc(j1); if j1>rows then j1:=rows;
        j2:=random(cols); inc(j2); if j2>cols then j2:=cols;
        j3:=random(rows); inc(j3); if j3>rows then j3:=rows;
        j4:=random(cols); inc(j4); if j4>cols then j4:=cols;
        if (j1<>j3)and(j2<>j4) then
        begin ExchgJigsawBlocks(j1,j2,j3,j4);
              inc(tot)
        end
  end
  *)
end;

procedure TForm1.RowtoRight1Click(Sender: TObject);
const c : boolean = true;
begin if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled');
        exit
  end;
  if c then //we will see this message only once
  begin
  showmessage('Move cursor to any location on the row, by just 1 click cells in the row'+
  ' will be rotated by 1 cell to right'); c:=false
  end;
  jigaction:=RotateRowRt; image1.cursor:=crSizeWE;
  sb.Panels[2].Text:='Rot row blocks to right'
end;

procedure TForm1.mnuRowtoLeftClick(Sender: TObject);
const c : boolean = true;
begin if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled');
        exit
  end;
  if c then
  begin
  showmessage('Move cursor to any location on the row, by just 1 click cells in the row'+
  ' will be rotated by 1 cell to left'); c:=false
  end;
  jigaction:=RotateRowLt; image1.cursor:=crSizeWE;
  sb.Panels[2].Text:='Rot row Blocks to left'
end;

procedure TForm1.ColumnUp1Click(Sender: TObject);
const c : boolean = true;
begin if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled');
        exit
  end;
  if c then
  begin //we will see message only once
  showmessage('Move cursor to any location on the column, by just 1 click cells in the column'+
  ' will be rotated up by 1 cell'); c:=false
  end;
  jigaction:=RotateColUp; image1.cursor:=crSizeNS;
  sb.Panels[2].Text:='Rot column block up'
end;

procedure TForm1.ColumnDn1Click(Sender: TObject);
const c : boolean = true;
begin if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled');
        exit
  end;
  if c then
  begin
  showmessage('Move cursor to any location on the column, by just 1 click cells in the column'+
  ' will be rotated down by 1 cell');
  c:=false
  end;
  jigaction:=RotateColdn; image1.cursor:=crSizeNS;
  sb.Panels[2].Text:='Rot column block down'
end;

procedure TForm1.Writeblockno1Click(Sender: TObject);
var i,j,k,w,h,cw,ch,x,y,blend : integer;  t : tbitmap;

procedure NumOutTransp(s: string );
var   w,h : integer;
begin destbitmap.Canvas.Font:=frmmisc.FontDialog.Font;
      h:=destbitmap.Canvas.TextHeight('H');
      w:=destbitmap.Canvas.Textwidth(s);
      destbitmap.Width:=w; destbitmap.Height:=h;
      srcbitmap.Width:=w; srcbitmap.Height:=h;
      t.Width:=w; t.Height:=h;
      destbitmap.Canvas.CopyRect(rect(0,0,w,h),jigbitmap.canvas,rect(x,y,x+w,y+h));

      destbitmap.Canvas.Brush.Style:=bsclear;
      destbitmap.Canvas.TextOut(0,0,s);

      srcbitmap.Canvas.CopyRect(rect(0,0,w,h),jigbitmap.canvas,rect(x,y,x+w,y+h));
      BlendBitmap(srcbitmap,destbitmap,t,blend);
      destbitmap.Canvas.Draw(0,0,t)
end;


begin
  if (ready=false)or(frmmisc.cbusegrid.Checked=false) then
  begin showmessage('Grid lines not enabled');
        exit
  end;
  k:=0; t:=Tbitmap.Create; t.PixelFormat:=pf32bit;
  sb.Panels[2].Text:='Trasnparent text';
  with frmmisc do
  begin
      w:=jigbitmap.Width div Totcols; h:=jigbitmap.Height div Totrows;
      blend:=strtointdef(edit2.text,100); if (blend<4)or(blend>100) then blend:=100;
  for i:=1 to Totrows do
  for j:=1 to Totcols do
  begin inc(k); x:=(j-1)*w+7; y:=(i-1)*h+5;
        NumOutTransp(inttostr(k));
        cw:=destbitmap.Width; ch:=destbitmap.Height;
        jigbitmap.Canvas.CopyRect(rect(x,y,x+cw,y+ch),destbitmap.canvas,rect(0,0,cw,ch));
  end;
  image1.Picture.Bitmap.Assign(jigbitmap); t.Free
  end
end;

procedure TForm1.mnuShrinkimageClick(Sender: TObject);
begin image1.Cursor:=crDefault; frmresizeimg.ShowModal
end;


procedure TForm1.Pasteimage1Click(Sender: TObject);
begin
 if Clipboard.HasFormat(CF_BITMAP) then
 begin ready:=false; frmmisc.cbusegrid.checked:=false;
       mainbitmap.Assign(clipboard);
       jigbitmap.Assign(mainbitmap);
       image1.Picture.Bitmap.Assign(mainbitmap); ready:=true
 end else
 showmessage('No image exists in clipboard')
end;








end.
